'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RELOAD_CHANNEL = 'Breakfast::LiveReloadChannel';

var LiveReloader = function () {
  function LiveReloader(settings) {
    _classCallCheck(this, LiveReloader);

    this.settings = settings;
  }

  _createClass(LiveReloader, [{
    key: 'buildFreshUrl',
    value: function buildFreshUrl(url) {
      var date = Math.round(Date.now() / 1000).toString();
      url = url.replace(/(\&|\\?)version=\d*/, '');

      return '' + url + (url.indexOf('?') >= 0 ? '&' : '?') + 'version=' + date;
    }
  }, {
    key: 'cssReload',
    value: function cssReload(strategy) {
      var _this = this;

      switch (strategy) {
        case 'hot':
          var reloadableLinkElements = window.top.document.querySelectorAll('link[rel=stylesheet]:not([data-no-reload]):not([data-pending-removal])');

          [].slice.call(reloadableLinkElements).filter(function (link) {
            return link.href;
          }).forEach(function (link) {
            return link.href = _this.buildFreshUrl(link.href);
          });

          // Repaint
          var browser = navigator.userAgent.toLowerCase();

          if (browser.indexOf('chrome') > -1) {
            setTimeout(function () {
              document.body.offsetHeight;
            }, 25);
          }
          break;
        case 'page':
          window.top.location.reload();
          break;
        case 'off':
          break;
      }
    }
  }, {
    key: 'jsReload',
    value: function jsReload(strategy) {
      switch (strategy) {
        case 'page':
          window.top.location.reload();
          break;
        case 'off':
          break;
      }
    }
  }, {
    key: 'htmlReload',
    value: function htmlReload(strategy) {
      switch (strategy) {
        case 'turbolinks':
          var location = window.top.location;

          if (this.turbolinksAvailable() && !this.onErrorPage()) {
            Turbolinks.visit(location);
          } else {
            location.reload();
          }
          break;
        case 'page':
          window.top.location.reload();
          break;
        case 'off':
          break;
      }
    }
  }, {
    key: 'rubyReload',
    value: function rubyReload(strategy) {
      switch (strategy) {
        case 'turbolinks':
          var location = window.top.location;

          if (this.turbolinksAvailable() && !this.onErrorPage()) {
            Turbolinks.visit(location);
          } else {
            location.reload();
          }
          break;
        case 'page':
          window.top.location.reload();
          break;
        case 'off':
          break;
      }
    }
  }, {
    key: 'turbolinksAvailable',
    value: function turbolinksAvailable() {
      return typeof Turbolinks !== 'undefined';
    }
    // If user is on an error page and they fix the error and re-render using
    // turbolinks than the CSS from the Rails error page will hang around. Will
    // initiate a full refresh to get rid of it.

  }, {
    key: 'onErrorPage',
    value: function onErrorPage() {
      return document.title.indexOf('Exception caught') !== -1;
    }
  }, {
    key: 'init',
    value: function init() {
      var _this2 = this;

      var reloaders = {
        js: this.jsReload.bind(this),
        css: this.cssReload.bind(this),
        html: this.htmlReload.bind(this),
        slim: this.htmlReload.bind(this),
        haml: this.htmlReload.bind(this),
        rb: this.rubyReload.bind(this)
      };

      document.addEventListener('DOMContentLoaded', function () {
        _this2.settings.cable.subscriptions.create(RELOAD_CHANNEL, {
          received: function received(data) {
            var reloader = reloaders[data.extension];
            reloader(_this2.settings.strategies[data.extension]);
          }
        });
      });
    }
  }]);

  return LiveReloader;
}();

module.exports = LiveReloader;