'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var LOCAL_STORAGE_KEY = 'breakfast-rails-settings';
var ActionCable = require('actioncable');

var Settings = function () {
  function Settings() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Settings);

    this.options = options;
    this.host = options.host;
    this.port = options.port;
    this.strategies = this.determineStrategies();
    this.statusBarLocation = options.statusBarLocation;
    this.cable = ActionCable.createConsumer('ws://' + this.host + ':' + this.port + '/cable');
    this.log = this.storedSettings().log || {};

    this.save();
  }

  _createClass(Settings, [{
    key: 'save',
    value: function save() {
      localStorage.setItem(LOCAL_STORAGE_KEY, JSON.stringify({
        host: this.host,
        port: this.port,
        strategies: this.strategies,
        log: this.log
      }));
    }
  }, {
    key: 'determineStrategies',
    value: function determineStrategies() {
      var defaults = this.options.strategies || {};
      var existing = this.storedSettings().strategies || {};

      return Object.assign(defaults, existing);
    }
  }, {
    key: 'updateStrategies',
    value: function updateStrategies(strategy) {
      this.strategies = Object.assign(this.strategies, strategy);
      this.save();
    }
  }, {
    key: 'updateLog',
    value: function updateLog(log) {
      this.log = log;
      this.save();
    }
  }, {
    key: 'storedSettings',
    value: function storedSettings() {
      return JSON.parse(localStorage.getItem(LOCAL_STORAGE_KEY)) || {};
    }
  }]);

  return Settings;
}();

module.exports = Settings;